ConvergeFu = AceLibrary("AceAddon-2.0"):new("AceConsole-2.0", "AceDB-2.0", "FuBarPlugin-2.0"); 
local L = AceLibrary("AceLocale-2.2"):new("ConvergeFu"); 
local Tablet = AceLibrary("Tablet-2.0"); 

ConvergeFu:RegisterDB("ConvergeFuDB");
ConvergeFu:RegisterDefaults("profile", {
  guildName    = "Converge",
  searchTarget = "Broliant",
} )
ConvergeFu.hasIcon = true; 
ConvergeFu.defaultPosition = "RIGHT"; 

ConvergeFu.consoleOptions = { 
   type = 'group', 
   args = { 
      announce = { 
         name = L["mainmenu-announce-title"], 
         type = 'group', 
         desc = L["mainmenu-announce-descr"], 
         args = { 
            guild = { 
               name = L["ann-guild-title"], 
               type = 'group', 
               desc = L["ann-guild-descr"], 
               args = {
                  invites = { 
                     name = L["ann-guild-raid-invite-title"], 
                     type = 'group', 
                     desc = L["ann-guild-raid-invite-descr"], 
                     args = {
                        banasea ={ 
                           name = L["common-officer-name-banasea"], 
                           desc = L["ann-guild-raid-invite-officer-descr"], 
                           type = 'execute', 
                           func = function() 
                              ConvergeFu:AnnounceRaidInvite(L["common-officer-name-banasea"], "GUILD")
                           end
                        },
                        broliant ={ 
                           name = L["common-officer-name-broliant"], 
                           desc = L["ann-guild-raid-invite-officer-descr"], 
                           type = 'execute', 
                           func = function() 
                              ConvergeFu:AnnounceRaidInvite(L["common-officer-name-broliant"], "GUILD")
                           end
                        },
                        jawa ={ 
                           name = L["common-officer-name-jawa"], 
                           desc = L["ann-guild-raid-invite-officer-descr"], 
                           type = 'execute', 
                           func = function() 
                              ConvergeFu:AnnounceRaidInvite(L["common-officer-name-jawa"], "GUILD")
                           end
                        },     
                        letita ={ 
                           name = L["common-officer-name-letita"], 
                           desc = L["ann-guild-raid-invite-officer-descr"], 
                           type = 'execute', 
                           func = function() 
                              ConvergeFu:AnnounceRaidInvite(L["common-officer-name-letita"], "GUILD")
                           end 
                        },                     
                        lyamblade ={ 
                           name = L["common-officer-name-lyamblade"], 
                           desc = L["ann-guild-raid-invite-officer-descr"], 
                           type = 'execute', 
                           func = function() 
                              ConvergeFu:AnnounceRaidInvite(L["common-officer-name-lyamblade"], "GUILD")
                           end 
                        },            
                        paraply ={ 
                           name = L["common-officer-name-paraply"], 
                           desc = L["ann-guild-raid-invite-officer-descr"], 
                           type = 'execute', 
                           func = function() 
                              ConvergeFu:AnnounceRaidInvite(L["common-officer-name-paraply"], "GUILD")
                           end 
                        },            
                        vanhelgan ={ 
                           name = L["common-officer-name-vanhelgan"], 
                           desc = L["ann-guild-raid-invite-officer-descr"], 
                           type = 'execute', 
                           func = function() 
                              ConvergeFu:AnnounceRaidInvite(L["common-officer-name-vanhelgan"], "GUILD")
                           end
                        },
                        zmall ={ 
                           name = L["common-officer-name-zmall"], 
                           desc = L["ann-guild-raid-invite-officer-descr"], 
                           type = 'execute', 
                           func = function() 
                              ConvergeFu:AnnounceRaidInvite(L["common-officer-name-zmall"], "GUILD")
                           end 
                        }
                     }
                  },
                  queue = { 
                     name = L["ann-guild-wait-list-title"], 
                     type = 'group', 
                     desc = L["ann-guild-wait-list-descr"], 
                     args = {
                        banasea ={ 
                           name = L["common-officer-name-banasea"], 
                           desc = L["ann-guild-wait-list-officer-descr"], 
                           type = 'execute', 
                           func = function() 
                              ConvergeFu:AnnounceWaitList(L["common-officer-name-banasea"], "GUILD")
                           end
                        },
                        broliant ={ 
                           name = L["common-officer-name-broliant"], 
                           desc = L["ann-guild-wait-list-officer-descr"], 
                           type = 'execute', 
                           func = function() 
                             ConvergeFu:AnnounceWaitList(L["common-officer-name-broliant"], "GUILD")
                           end 
                        },
                        jawa ={ 
                           name = L["common-officer-name-jawa"], 
                           desc = L["ann-guild-wait-list-officer-descr"], 
                           type = 'execute', 
                           func = function() 
                             ConvergeFu:AnnounceWaitList(L["common-officer-name-jawa"], "GUILD")
                           end
                        },     
                        letita ={ 
                           name = L["common-officer-name-letita"], 
                           desc = L["ann-guild-wait-list-officer-descr"], 
                           type = 'execute', 
                           func = function() 
                             ConvergeFu:AnnounceWaitList(L["common-officer-name-letita"], "GUILD")
                           end 
                        },                     
                        lyamblade ={ 
                           name = L["common-officer-name-lyamblade"], 
                           desc = L["ann-guild-wait-list-officer-descr"], 
                           type = 'execute', 
                           func = function() 
                             ConvergeFu:AnnounceWaitList(L["common-officer-name-lyamblade"], "GUILD")
                           end 
                        },            
                        paraply ={ 
                           name = L["common-officer-name-paraply"], 
                           desc = L["ann-guild-wait-list-officer-descr"], 
                           type = 'execute', 
                           func = function() 
                             ConvergeFu:AnnounceWaitList(L["common-officer-name-paraply"], "GUILD")
                           end 
                        },            
                        vanhelgan ={ 
                           name = L["common-officer-name-vanhelgan"], 
                           desc = L["ann-guild-wait-list-officer-descr"], 
                           type = 'execute', 
                           func = function() 
                             ConvergeFu:AnnounceWaitList(L["common-officer-name-vanhelgan"], "GUILD")
                           end
                        }, 
                        zmall ={ 
                           name = L["common-officer-name-zmall"], 
                           desc = L["ann-guild-wait-list-officer-descr"], 
                           type = 'execute', 
                           func = function() 
                             ConvergeFu:AnnounceWaitList(L["common-officer-name-zmall"], "GUILD")
                           end 
                        } 
                     }
                  },
                  welcome_new_trial = { 
                     name = L["ann-guild-new-trial-title"], 
                     desc = L["ann-guild-new-trial-descr"], 
                     type = 'execute', 
                     func = function() 
                        SendChatMessage(L["ann-guild-new-trial-01-msg"], "GUILD")
                        SendChatMessage(L["ann-guild-new-trial-02-msg"], "GUILD")
                        SendChatMessage(L["ann-guild-new-trial-03-msg"], "GUILD")
                        SendChatMessage(L["ann-guild-new-trial-04-msg"], "GUILD")
                        SendChatMessage(L["ann-guild-new-trial-05-msg"], "GUILD")
                        SendChatMessage(L["ann-guild-new-trial-06-msg"], "GUILD")
                        SendChatMessage(L["ann-guild-new-trial-07-msg"], "GUILD")
                        SendChatMessage(L["ann-guild-new-trial-08-msg"], "GUILD")
                        SendChatMessage(L["ann-guild-new-trial-09-msg"], "GUILD")
                        SendChatMessage(L["ann-guild-new-trial-10-msg"], "GUILD")
                        SendChatMessage(L["ann-guild-new-trial-11-msg"], "GUILD")
                     end 
                  },
                  welcome_new_alt = { 
                     name = L["ann-guild-new-alt-title"], 
                     desc = L["ann-guild-new-alt-descr"], 
                     type = 'execute', 
                     func = function() 
                       SendChatMessage(L["ann-guild-new-alt-01-msg"], "GUILD")
                       SendChatMessage(L["ann-guild-new-alt-02-msg"], "GUILD")
                       SendChatMessage(L["ann-guild-new-alt-03-msg"], "GUILD")
                       SendChatMessage(L["ann-guild-new-alt-04-msg"], "GUILD")
                       SendChatMessage(L["ann-guild-new-alt-05-msg"], "GUILD")
                       SendChatMessage(L["ann-guild-new-alt-06-msg"], "GUILD")
                       SendChatMessage(L["ann-guild-new-alt-07-msg"], "GUILD")
                       SendChatMessage(L["ann-guild-new-alt-08-msg"], "GUILD")
                       SendChatMessage(L["ann-guild-new-alt-09-msg"], "GUILD")
                       SendChatMessage(L["ann-guild-new-alt-10-msg"], "GUILD")
                       SendChatMessage(L["ann-guild-new-alt-11-msg"], "GUILD")
                     end 
                  },  
                  trial_ended ={ 
                     name = L["ann-guild-trial-ended-title"], 
                     desc = L["ann-guild-trial-ended-descr"], 
                     type = 'execute', 
                     func = function() 
                       SendChatMessage(L["ann-guild-trial-ended-01-msg"], "GUILD")
                       SendChatMessage(L["ann-guild-trial-ended-02-msg"], "GUILD")
                       SendChatMessage(L["ann-guild-trial-ended-03-msg"], "GUILD")
                       SendChatMessage(L["ann-guild-trial-ended-04-msg"], "GUILD")
                       SendChatMessage(L["ann-guild-trial-ended-05-msg"], "GUILD")
                       SendChatMessage(L["ann-guild-trial-ended-06-msg"], "GUILD")
                       SendChatMessage(L["ann-guild-trial-ended-07-msg"], "GUILD")
                       SendChatMessage(L["ann-guild-trial-ended-08-msg"], "GUILD")
                       SendChatMessage(L["ann-guild-trial-ended-09-msg"], "GUILD")
                       SendChatMessage(L["ann-guild-trial-ended-10-msg"], "GUILD")
                       SendChatMessage(L["ann-guild-trial-ended-11-msg"], "GUILD")
                     end
                  },             
                  promote_trial ={ 
                     name = L["ann-guild-promote-title"], 
                     desc = L["ann-guild-promote-descr"], 
                     type = 'execute', 
                     func = function() 
                       SendChatMessage(L["ann-guild-promote-01-msg"], "GUILD")
                       SendChatMessage(L["ann-guild-promote-02-msg"], "GUILD")
                       SendChatMessage(L["ann-guild-promote-03-msg"], "GUILD")
                       SendChatMessage(L["ann-guild-promote-04-msg"], "GUILD")
                       SendChatMessage(L["ann-guild-promote-05-msg"], "GUILD")
                       SendChatMessage(L["ann-guild-promote-06-msg"], "GUILD")
                       SendChatMessage(L["ann-guild-promote-07-msg"], "GUILD")
                       SendChatMessage(L["ann-guild-promote-08-msg"], "GUILD")
                       SendChatMessage(L["ann-guild-promote-09-msg"], "GUILD")
                       SendChatMessage(L["ann-guild-promote-10-msg"], "GUILD")
                       SendChatMessage(L["ann-guild-promote-11-msg"], "GUILD")
                     end
                  }                  
               }
            },
            raid = {
               name = L["ann-raid-title"], 
               type = 'group', 
               desc = L["ann-raid-descr"], 
               args = {             
                 quest = {
                    name = L["ann-raid-quest-title"], 
                    type = 'group', 
                    desc = L["ann-raid-quest-descr"], 
                    args = { 
                       quest_01 = { 
                          name = L["ann-common-promotion-quest-01-title"], 
                          desc = L["ann-common-promotion-quest-descr"], 
                          type = 'execute', 
                          func = function() 
                             SendChatMessage(L["ann-common-promotion-quest-txt-01-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-txt-02-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-txt-03-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-txt-04-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-01-01-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-txt-04-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-01-02-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-01-03-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-01-04-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-txt-05-msg"], "RAID")
                          end 
                       },
                       quest_02 = { 
                          name = L["ann-common-promotion-quest-02-title"], 
                          desc = L["ann-common-promotion-quest-descr"], 
                          type = 'execute', 
                          func = function() 
                             SendChatMessage(L["ann-common-promotion-quest-txt-01-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-txt-02-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-txt-03-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-txt-04-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-02-01-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-txt-04-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-02-02-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-02-03-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-02-04-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-txt-05-msg"], "RAID")
                          end 
                       },
                       quest_03 = { 
                          name = L["ann-common-promotion-quest-03-title"], 
                          desc = L["ann-common-promotion-quest-descr"], 
                          type = 'execute', 
                          func = function() 
                             SendChatMessage(L["ann-common-promotion-quest-txt-01-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-txt-02-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-txt-03-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-txt-04-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-03-01-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-txt-04-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-03-02-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-03-03-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-03-04-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-txt-05-msg"], "RAID")
                          end 
                       },
                       quest_04 = { 
                          name = L["ann-common-promotion-quest-04-title"], 
                          desc = L["ann-common-promotion-quest-descr"], 
                          type = 'execute', 
                          func = function() 
                             SendChatMessage(L["ann-common-promotion-quest-txt-01-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-txt-02-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-txt-03-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-txt-04-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-04-01-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-txt-04-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-04-02-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-04-03-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-04-04-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-txt-05-msg"], "RAID")
                          end 
                       },
                       quest_05 = { 
                          name = L["ann-common-promotion-quest-05-title"], 
                          desc = L["ann-common-promotion-quest-descr"], 
                          type = 'execute', 
                          func = function() 
                             SendChatMessage(L["ann-common-promotion-quest-txt-01-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-txt-02-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-txt-03-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-txt-04-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-05-01-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-txt-04-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-05-02-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-05-03-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-05-04-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-txt-05-msg"], "RAID")
                          end 
                       },
                       quest_06 = { 
                          name = L["ann-common-promotion-quest-06-title"], 
                          desc = L["ann-common-promotion-quest-descr"], 
                          type = 'execute', 
                          func = function() 
                             SendChatMessage(L["ann-common-promotion-quest-txt-01-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-txt-02-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-txt-03-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-txt-04-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-06-01-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-txt-04-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-06-02-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-06-03-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-06-04-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-txt-05-msg"], "RAID")
                          end 
                       },
                       quest_07 = { 
                          name = L["ann-common-promotion-quest-07-title"], 
                          desc = L["ann-common-promotion-quest-descr"], 
                          type = 'execute', 
                          func = function() 
                             SendChatMessage(L["ann-common-promotion-quest-txt-01-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-txt-02-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-txt-03-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-txt-04-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-07-01-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-txt-04-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-07-02-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-07-03-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-07-04-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-txt-05-msg"], "RAID")
                          end 
                       },
                       quest_08 = { 
                          name = L["ann-common-promotion-quest-08-title"], 
                          desc = L["ann-common-promotion-quest-descr"], 
                          type = 'execute', 
                          func = function() 
                             SendChatMessage(L["ann-common-promotion-quest-txt-01-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-txt-02-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-txt-03-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-txt-04-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-08-01-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-txt-04-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-08-02-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-08-03-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-08-04-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-txt-05-msg"], "RAID")
                          end 
                       },
                       quest_09 = { 
                          name = L["ann-common-promotion-quest-09-title"], 
                          desc = L["ann-common-promotion-quest-descr"], 
                          type = 'execute', 
                          func = function() 
                             SendChatMessage(L["ann-common-promotion-quest-txt-01-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-txt-02-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-txt-03-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-txt-04-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-09-01-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-txt-04-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-09-02-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-09-03-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-09-04-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-txt-05-msg"], "RAID")
                          end 
                       },
                       quest_10 = { 
                          name = L["ann-common-promotion-quest-10-title"], 
                          desc = L["ann-common-promotion-quest-descr"], 
                          type = 'execute', 
                          func = function() 
                             SendChatMessage(L["ann-common-promotion-quest-txt-01-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-txt-02-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-txt-03-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-txt-04-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-10-01-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-txt-04-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-10-02-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-10-03-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-10-04-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-txt-05-msg"], "RAID")
                          end 
                       },
                       quest_11 = { 
                          name = L["ann-common-promotion-quest-11-title"], 
                          desc = L["ann-common-promotion-quest-descr"], 
                          type = 'execute', 
                          func = function() 
                             SendChatMessage(L["ann-common-promotion-quest-txt-01-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-txt-02-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-txt-03-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-txt-04-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-11-01-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-txt-04-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-11-02-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-11-03-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-11-04-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-txt-05-msg"], "RAID")
                          end 
                       },
                       quest_12 = { 
                          name = L["ann-common-promotion-quest-12-title"], 
                          desc = L["ann-common-promotion-quest-descr"], 
                          type = 'execute', 
                          func = function() 
                             SendChatMessage(L["ann-common-promotion-quest-txt-01-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-txt-02-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-txt-03-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-txt-04-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-12-01-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-txt-04-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-12-02-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-12-03-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-12-04-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-txt-05-msg"], "RAID")
                          end 
                       },
                       quest_13 = { 
                          name = L["ann-common-promotion-quest-13-title"], 
                          desc = L["ann-common-promotion-quest-descr"], 
                          type = 'execute', 
                          func = function() 
                             SendChatMessage(L["ann-common-promotion-quest-txt-01-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-txt-02-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-txt-03-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-txt-04-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-13-01-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-txt-04-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-13-02-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-13-03-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-13-04-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-txt-05-msg"], "RAID")
                          end 
                       },
                       quest_14 = { 
                          name = L["ann-common-promotion-quest-14-title"], 
                          desc = L["ann-common-promotion-quest-descr"], 
                          type = 'execute', 
                          func = function() 
                             SendChatMessage(L["ann-common-promotion-quest-txt-01-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-txt-02-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-txt-03-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-txt-04-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-14-01-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-txt-04-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-14-02-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-14-03-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-14-04-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-txt-05-msg"], "RAID")
                          end 
                       },
                       quest_15 = { 
                          name = L["ann-common-promotion-quest-15-title"], 
                          desc = L["ann-common-promotion-quest-descr"], 
                          type = 'execute', 
                          func = function() 
                             SendChatMessage(L["ann-common-promotion-quest-txt-01-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-txt-02-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-txt-03-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-txt-04-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-15-01-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-txt-04-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-15-02-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-15-03-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-15-04-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-txt-05-msg"], "RAID")
                          end 
                       },
                       quest_16 = { 
                          name = L["ann-common-promotion-quest-16-title"], 
                          desc = L["ann-common-promotion-quest-descr"], 
                          type = 'execute', 
                          func = function() 
                             SendChatMessage(L["ann-common-promotion-quest-txt-01-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-txt-02-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-txt-03-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-txt-04-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-16-01-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-txt-04-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-16-02-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-16-03-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-16-04-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-txt-05-msg"], "RAID")
                          end 
                       },
                       quest_17 = { 
                          name = L["ann-common-promotion-quest-17-title"], 
                          desc = L["ann-common-promotion-quest-descr"], 
                          type = 'execute', 
                          func = function() 
                             SendChatMessage(L["ann-common-promotion-quest-txt-01-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-txt-02-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-txt-03-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-txt-04-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-17-01-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-txt-04-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-17-02-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-17-03-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-17-04-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-txt-05-msg"], "RAID")
                          end 
                       },
                       quest_18 = { 
                          name = L["ann-common-promotion-quest-18-title"], 
                          desc = L["ann-common-promotion-quest-descr"], 
                          type = 'execute', 
                          func = function() 
                             SendChatMessage(L["ann-common-promotion-quest-txt-01-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-txt-02-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-txt-03-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-txt-04-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-18-01-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-txt-04-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-18-02-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-18-03-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-18-04-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-txt-05-msg"], "RAID")
                          end 
                       },
                       quest_19 = { 
                          name = L["ann-common-promotion-quest-19-title"], 
                          desc = L["ann-common-promotion-quest-descr"], 
                          type = 'execute', 
                          func = function() 
                             SendChatMessage(L["ann-common-promotion-quest-txt-01-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-txt-02-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-txt-03-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-txt-04-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-19-01-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-txt-04-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-19-02-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-19-03-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-19-04-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-txt-05-msg"], "RAID")
                          end 
                       },
                       quest_20 = { 
                          name = L["ann-common-promotion-quest-20-title"], 
                          desc = L["ann-common-promotion-quest-descr"], 
                          type = 'execute', 
                          func = function() 
                             SendChatMessage(L["ann-common-promotion-quest-txt-01-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-txt-02-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-txt-03-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-txt-04-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-20-01-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-txt-04-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-20-02-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-20-03-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-20-04-msg"], "RAID")
                             SendChatMessage(L["ann-common-promotion-quest-txt-05-msg"], "RAID")
                          end 
                       }
                    }
                 },
                 kill_order = { 
                    name = L["ann-common-kill-order-title"], 
                    desc = L["ann-common-kill-order-descr"], 
                    type = 'execute', 
                    func = function() 
                       SendChatMessage(L["ann-common-kill-order-01-msg"], "RAID")
                       SendChatMessage(L["ann-common-kill-order-02-msg"], "RAID")
                       SendChatMessage(L["ann-common-kill-order-03-msg"], "RAID")
                       SendChatMessage(L["ann-common-kill-order-04-msg"], "RAID")
                       SendChatMessage(L["ann-common-kill-order-05-msg"], "RAID")
                       SendChatMessage(L["ann-common-kill-order-06-msg"], "RAID")
                       SendChatMessage(L["ann-common-kill-order-07-msg"], "RAID")
                       SendChatMessage(L["ann-common-kill-order-08-msg"], "RAID")
                       SendChatMessage(L["ann-common-kill-order-09-msg"], "RAID")
                       SendChatMessage(L["ann-common-kill-order-10-msg"], "RAID")
                       SendChatMessage(L["ann-common-kill-order-11-msg"], "RAID")
                       SendChatMessage(L["ann-common-kill-order-12-msg"], "RAID")
                    end 
                 },
                 ventrilo = { 
                    name = L["ann-common-ventrilo-title"], 
                    desc = L["ann-common-ventrilo-descr"], 
                    type = 'execute', 
                    func = function() 
                       SendChatMessage(L["ann-common-ventrilo-01-msg"], "RAID")
                       SendChatMessage(L["ann-common-ventrilo-02-msg"], "RAID")
                       SendChatMessage(L["ann-common-ventrilo-03-msg"], "RAID")
                       SendChatMessage(L["ann-common-ventrilo-04-msg"], "RAID")
                       SendChatMessage(L["ann-common-ventrilo-05-msg"], "RAID")
                       SendChatMessage(L["ann-common-ventrilo-06-msg"], "RAID")
                       SendChatMessage(L["ann-common-ventrilo-07-msg"], "RAID")
                       SendChatMessage(L["ann-common-ventrilo-08-msg"], "RAID")
                       SendChatMessage(L["ann-common-ventrilo-09-msg"], "RAID")
                       SendChatMessage(L["ann-common-ventrilo-10-msg"], "RAID")
                       SendChatMessage(L["ann-common-ventrilo-11-msg"], "RAID")
                       SendChatMessage(L["ann-common-ventrilo-12-msg"], "RAID")
                       SendChatMessage(L["ann-common-ventrilo-13-msg"], "RAID")
                       SendChatMessage(L["ann-common-ventrilo-14-msg"], "RAID")
                       SendChatMessage(L["ann-common-ventrilo-15-msg"], "RAID")
                       SendChatMessage(L["ann-common-ventrilo-16-msg"], "RAID")
                    end 
                 },               
                 raid_begin = { 
                    name = L["ann-raid-raid-begin-title"], 
                    desc = L["ann-raid-raid-begin-descr"], 
                    type = 'execute', 
                    func = function() 
                      SendChatMessage(L["ann-raid-raid-begin-02-msg"], "RAID_WARNING")
                      SendChatMessage(L["ann-raid-raid-begin-14-msg"], "RAID_WARNING")
  
                      SendChatMessage(L["ann-raid-raid-begin-01-msg"], "RAID")
                      SendChatMessage(L["ann-raid-raid-begin-02-msg"], "RAID")
                      SendChatMessage(L["ann-raid-raid-begin-03-msg"], "RAID")
                      SendChatMessage(L["ann-raid-raid-begin-04-msg"], "RAID")
                      SendChatMessage(L["ann-raid-raid-begin-05-msg"], "RAID")
                      SendChatMessage(L["ann-raid-raid-begin-06-msg"], "RAID")
                      SendChatMessage(L["ann-raid-raid-begin-07-msg"], "RAID")
                      SendChatMessage(L["ann-raid-raid-begin-08-msg"], "RAID")
                      SendChatMessage(L["ann-raid-raid-begin-09-msg"], "RAID")
                      SendChatMessage(L["ann-raid-raid-begin-10-msg"], "RAID")
                      SendChatMessage(L["ann-raid-raid-begin-11-msg"], "RAID")
                      SendChatMessage(L["ann-raid-raid-begin-12-msg"], "RAID")
                      SendChatMessage(L["ann-raid-raid-begin-13-msg"], "RAID")
                    end 
                 },               
                 raid_end = { 
                    name = L["ann-raid-raid-end-title"], 
                    desc = L["ann-raid-raid-end-descr"], 
                    type = 'execute', 
                    func = function() 
                      ConvergeFu:AnnounceRaidEnd("RAID")
                    end 
                 },
                 priority = { 
                    name = L["ann-common-looting-order-title"], 
                    desc = L["ann-common-looting-order-descr"], 
                    type = 'execute', 
                    func = function() 
                       SendChatMessage(L["ann-common-looting-order-01-msg"], "RAID")
                       SendChatMessage(L["ann-common-looting-order-02-msg"], "RAID")
                       SendChatMessage(L["ann-common-looting-order-03-msg"], "RAID")
                       SendChatMessage(L["ann-common-looting-order-04-msg"], "RAID")
                       SendChatMessage(L["ann-common-looting-order-05-msg"], "RAID")
                       SendChatMessage(L["ann-common-looting-order-06-msg"], "RAID")
                       SendChatMessage(L["ann-common-looting-order-07-msg"], "RAID")
                       SendChatMessage(L["ann-common-looting-order-08-msg"], "RAID")
                       SendChatMessage(L["ann-common-looting-order-09-msg"], "RAID")
                       SendChatMessage(L["ann-common-looting-order-10-msg"], "RAID")
                       SendChatMessage(L["ann-common-looting-order-11-msg"], "RAID")
                       SendChatMessage(L["ann-common-looting-order-12-msg"], "RAID")
                       SendChatMessage(L["ann-common-looting-order-13-msg"], "RAID")
                       SendChatMessage(L["ann-common-looting-order-14-msg"], "RAID")
                       SendChatMessage(L["ann-common-looting-order-15-msg"], "RAID")
                    end 
                 }
              }
          },
            party = {
               name = L["ann-party-title"], 
               type = 'group', 
               desc = L["ann-party-descr"], 
               args = {             
                 kill_order ={ 
                    name = L["ann-common-kill-order-title"], 
                    desc = L["ann-common-kill-order-descr"], 
                    type = 'execute', 
                    func = function() 
                       SendChatMessage(L["ann-common-kill-order-01-msg"], "PARTY")
                       SendChatMessage(L["ann-common-kill-order-02-msg"], "PARTY")
                       SendChatMessage(L["ann-common-kill-order-03-msg"], "PARTY")
                       SendChatMessage(L["ann-common-kill-order-04-msg"], "PARTY")
                       SendChatMessage(L["ann-common-kill-order-05-msg"], "PARTY")
                       SendChatMessage(L["ann-common-kill-order-06-msg"], "PARTY")
                       SendChatMessage(L["ann-common-kill-order-07-msg"], "PARTY")
                       SendChatMessage(L["ann-common-kill-order-08-msg"], "PARTY")
                       SendChatMessage(L["ann-common-kill-order-09-msg"], "PARTY")
                       SendChatMessage(L["ann-common-kill-order-10-msg"], "PARTY")
                       SendChatMessage(L["ann-common-kill-order-11-msg"], "PARTY")
                       SendChatMessage(L["ann-common-kill-order-12-msg"], "PARTY")
                    end 
                 },
                 ventrilo ={ 
                    name = L["ann-common-ventrilo-title"], 
                    desc = L["ann-common-ventrilo-descr"], 
                    type = 'execute', 
                    func = function() 
                       SendChatMessage(L["ann-common-ventrilo-01-msg"], "PARTY")
                       SendChatMessage(L["ann-common-ventrilo-02-msg"], "PARTY")
                       SendChatMessage(L["ann-common-ventrilo-03-msg"], "PARTY")
                       SendChatMessage(L["ann-common-ventrilo-04-msg"], "PARTY")
                       SendChatMessage(L["ann-common-ventrilo-05-msg"], "PARTY")
                       SendChatMessage(L["ann-common-ventrilo-06-msg"], "PARTY")
                       SendChatMessage(L["ann-common-ventrilo-07-msg"], "PARTY")
                       SendChatMessage(L["ann-common-ventrilo-08-msg"], "PARTY")
                       SendChatMessage(L["ann-common-ventrilo-09-msg"], "PARTY")
                       SendChatMessage(L["ann-common-ventrilo-10-msg"], "PARTY")
                       SendChatMessage(L["ann-common-ventrilo-11-msg"], "PARTY")
                       SendChatMessage(L["ann-common-ventrilo-12-msg"], "PARTY")
                       SendChatMessage(L["ann-common-ventrilo-13-msg"], "PARTY")
                       SendChatMessage(L["ann-common-ventrilo-14-msg"], "PARTY")
                       SendChatMessage(L["ann-common-ventrilo-15-msg"], "PARTY")
                       SendChatMessage(L["ann-common-ventrilo-16-msg"], "PARTY")
                    end 
                 },               
                 party_begin ={ 
                    name = L["ann-raid-raid-begin-title"], 
                    desc = L["ann-raid-raid-begin-descr"], 
                    type = 'execute', 
                    func = function() 
                      SendChatMessage(L["ann-raid-raid-begin-02-msg"], "RAID_WARNING")
                      SendChatMessage(L["ann-raid-raid-begin-14-msg"], "RAID_WARNING")
  
                      SendChatMessage(L["ann-raid-raid-begin-01-msg"], "PARTY")
                      SendChatMessage(L["ann-raid-raid-begin-02-msg"], "PARTY")
                      SendChatMessage(L["ann-raid-raid-begin-03-msg"], "PARTY")
                      SendChatMessage(L["ann-raid-raid-begin-04-msg"], "PARTY")
                      SendChatMessage(L["ann-raid-raid-begin-05-msg"], "PARTY")
                      SendChatMessage(L["ann-raid-raid-begin-06-msg"], "PARTY")
                      SendChatMessage(L["ann-raid-raid-begin-07-msg"], "PARTY")
                      SendChatMessage(L["ann-raid-raid-begin-08-msg"], "PARTY")
                      SendChatMessage(L["ann-raid-raid-begin-09-msg"], "PARTY")
                      SendChatMessage(L["ann-raid-raid-begin-10-msg"], "PARTY")
                      SendChatMessage(L["ann-raid-raid-begin-11-msg"], "PARTY")
                      SendChatMessage(L["ann-raid-raid-begin-12-msg"], "PARTY")
                      SendChatMessage(L["ann-raid-raid-begin-13-msg"], "PARTY")
                    end 
                 },               
                 party_end ={ 
                    name = L["ann-raid-raid-end-title"], 
                    desc = L["ann-raid-raid-end-descr"], 
                    type = 'execute', 
                    func = function() 
                      ConvergeFu:AnnounceRaidEnd("PARTY")
                    end 
                 },
                 priority ={ 
                    name = L["ann-common-looting-order-title"], 
                    desc = L["ann-common-looting-order-descr"], 
                    type = 'execute', 
                    func = function() 
                       SendChatMessage(L["ann-common-looting-order-01-msg"], "PARTY")
                       SendChatMessage(L["ann-common-looting-order-02-msg"], "PARTY")
                       SendChatMessage(L["ann-common-looting-order-03-msg"], "PARTY")
                       SendChatMessage(L["ann-common-looting-order-04-msg"], "PARTY")
                       SendChatMessage(L["ann-common-looting-order-05-msg"], "PARTY")
                       SendChatMessage(L["ann-common-looting-order-06-msg"], "PARTY")
                       SendChatMessage(L["ann-common-looting-order-07-msg"], "PARTY")
                       SendChatMessage(L["ann-common-looting-order-08-msg"], "PARTY")
                       SendChatMessage(L["ann-common-looting-order-09-msg"], "PARTY")
                       SendChatMessage(L["ann-common-looting-order-10-msg"], "PARTY")
                       SendChatMessage(L["ann-common-looting-order-11-msg"], "PARTY")
                       SendChatMessage(L["ann-common-looting-order-12-msg"], "PARTY")
                       SendChatMessage(L["ann-common-looting-order-13-msg"], "PARTY")
                       SendChatMessage(L["ann-common-looting-order-14-msg"], "PARTY")
                       SendChatMessage(L["ann-common-looting-order-15-msg"], "PARTY")
                    end 
                 }
              }
          },
            say = {
               name = L["ann-say-title"], 
               type = 'group', 
               desc = L["ann-say-descr"], 
               args = { 
                threat = { 
                   name = L["ann-say-threat-title"], 
                   desc = L["ann-say-threat-descr"], 
                   type = 'execute', 
                   func = function() SendChatMessage(L["ann-say-threat-msg"], "SAY") end
                 },
                evasion = { 
                   name = L["ann-say-evasion-title"], 
                   desc = L["ann-say-evasion-descr"], 
                   type = 'execute', 
                   func = function() SendChatMessage(L["ann-say-evasion-msg"], "SAY") end
                 },
                granny = { 
                   name = L["ann-say-granny-title"], 
                   desc = L["ann-say-granny-descr"], 
                   type = 'execute', 
                   func = function() SendChatMessage(L["ann-say-granny-msg"], "SAY") end
                 }
               }
            }         
         }
      },
      chat = { 
         name = L["mainmenu-chat-title"], 
         type = 'group', 
         desc = L["mainmenu-chat-descr"], 
         args = { 
            join = { 
               name = L["chat-join-title"], 
               type = 'group', 
               desc = L["chat-join-descr"], 
               args = {
                  condknight = { 
                     name = L["chat-condknight-title"], 
                     desc = L["chat-condknight-descr"], 
                     type = 'execute', 
                     func = function() ExecuteChatCommand("/join condknight") end 
                  },               
                  condruid = { 
                     name = L["chat-condruid-title"], 
                     desc = L["chat-condruid-descr"], 
                     type = 'execute', 
                     func = function() ExecuteChatCommand("/join condruid") end 
                  }, 
                  conhunter = { 
                     name = L["chat-conhunter-title"], 
                     desc = L["chat-conhunter-descr"], 
                     type = 'execute', 
                     func = function() ExecuteChatCommand("/join conhunter") end 
                  }, 
                  conmage = { 
                     name = L["chat-conmage-title"], 
                     desc = L["chat-conmage-descr"], 
                     type = 'execute', 
                     func = function() ExecuteChatCommand("/join conmage") end 
                  }, 
                  conpaladin = { 
                     name = L["chat-conpaladin-title"], 
                     desc = L["chat-conpaladin-descr"], 
                     type = 'execute', 
                     func = function() ExecuteChatCommand("/join conpaladin") end 
                  }, 
                  conpriest = { 
                     name = L["chat-conpriest-title"], 
                     desc = L["chat-conpriest-descr"], 
                     type = 'execute', 
                     func = function() ExecuteChatCommand("/join conpriest") end 
                  }, 
                  conrogue = { 
                     name = L["chat-conrogue-title"], 
                     desc = L["chat-conrogue-descr"], 
                     type = 'execute', 
                     func = function() ExecuteChatCommand("/join conrogue") end 
                  }, 
                  conshaman = { 
                     name = L["chat-conshaman-title"], 
                     desc = L["chat-conshaman-descr"], 
                     type = 'execute', 
                     func = function() ExecuteChatCommand("/join conshaman") end 
                  },
                  contank = { 
                     name = L["chat-contank-title"], 
                     desc = L["chat-contank-descr"], 
                     type = 'execute', 
                     func = function() ExecuteChatCommand("/join contank") end 
                  },                  
                  conlock = { 
                     name = L["chat-conlock-title"], 
                     desc = L["chat-conlock-descr"], 
                     type = 'execute', 
                     func = function() ExecuteChatCommand("/join conlock") end 
                  }, 
                  conwarrior = { 
                     name = L["chat-conwarrior-title"], 
                     desc = L["chat-conwarrior-descr"], 
                     type = 'execute', 
                     func = function() ExecuteChatCommand("/join conwarrior") end 
                  },
                  conhealer = { 
                     name = L["chat-conhealer-title"], 
                     desc = L["chat-conhealer-descr"], 
                     type = 'execute', 
                     func = function() ExecuteChatCommand("/join conhealer") end 
                  }
               }
            },
            leave = { 
               name = L["chat-leave-title"], 
               type = 'group', 
               desc = L["chat-leave-descr"], 
               args = {
                  condknight = { 
                     name = L["chat-condknight-title"], 
                     desc = L["chat-condknight-descr"], 
                     type = 'execute', 
                     func = function() ExecuteChatCommand("/leave condknight") end 
                  },                
                  condruid = { 
                     name = L["chat-condruid-title"], 
                     desc = L["chat-condruid-descr"], 
                     type = 'execute', 
                     func = function() ExecuteChatCommand("/leave condruid") end 
                  }, 
                  conhunter = { 
                     name = L["chat-conhunter-title"], 
                     desc = L["chat-conhunter-descr"], 
                     type = 'execute', 
                     func = function() ExecuteChatCommand("/leave conhunter") end 
                  }, 
                  conmage = { 
                     name = L["chat-conmage-title"], 
                     desc = L["chat-conmage-descr"], 
                     type = 'execute', 
                     func = function() ExecuteChatCommand("/leave conmage") end 
                  }, 
                  conpaladin = { 
                     name = L["chat-conpaladin-title"], 
                     desc = L["chat-conpaladin-descr"], 
                     type = 'execute', 
                     func = function() ExecuteChatCommand("/leave conpaladin") end 
                  }, 
                  conpriest = { 
                     name = L["chat-conpriest-title"], 
                     desc = L["chat-conpriest-descr"], 
                     type = 'execute', 
                     func = function() ExecuteChatCommand("/leave conpriest") end 
                  }, 
                  conrogue = { 
                     name = L["chat-conrogue-title"], 
                     desc = L["chat-conrogue-descr"], 
                     type = 'execute', 
                     func = function() ExecuteChatCommand("/leave conrogue") end 
                  }, 
                  conshaman = { 
                     name = L["chat-conshaman-title"], 
                     desc = L["chat-conshaman-descr"], 
                     type = 'execute', 
                     func = function() ExecuteChatCommand("/leave conshaman") end 
                  },
                  contank = { 
                     name = L["chat-contank-title"], 
                     desc = L["chat-contank-descr"], 
                     type = 'execute', 
                     func = function() ExecuteChatCommand("/leave contank") end 
                  },                  
                  conlock = { 
                     name = L["chat-conlock-title"], 
                     desc = L["chat-conlock-descr"], 
                     type = 'execute', 
                     func = function() ExecuteChatCommand("/leave conlock") end 
                  }, 
                  conwarrior = { 
                     name = L["chat-conwarrior-title"], 
                     desc = L["chat-conwarrior-descr"], 
                     type = 'execute', 
                     func = function() ExecuteChatCommand("/leave conwarrior") end 
                  },
                  conhealer = { 
                     name = L["chat-conhealer-title"], 
                     desc = L["chat-conhealer-descr"], 
                     type = 'execute', 
                     func = function() ExecuteChatCommand("/leave conhealer") end 
                  }
               }
            },
            who = {
               name = L["chat-who-title"], 
               type = 'group', 
               desc = L["chat-who-descr"], 
               args = {
                  condknight = { 
                     name = L["chat-condknight-title"], 
                     desc = L["chat-condknight-descr"], 
                     type = 'execute', 
                     func = function() ExecuteChatCommand("/chatwho condknight") end 
                  },                
                  condruid = { 
                     name = L["chat-condruid-title"], 
                     desc = L["chat-condruid-descr"], 
                     type = 'execute', 
                     func = function() ExecuteChatCommand("/chatwho condruid") end 
                  }, 
                  conhunter = { 
                     name = L["chat-conhunter-title"], 
                     desc = L["chat-conhunter-descr"], 
                     type = 'execute', 
                     func = function() ExecuteChatCommand("/chatwho conhunter") end 
                  }, 
                  conmage = { 
                     name = L["chat-conmage-title"], 
                     desc = L["chat-conmage-descr"], 
                     type = 'execute', 
                     func = function() ExecuteChatCommand("/chatwho conmage") end 
                  }, 
                  conpaladin = { 
                     name = L["chat-conpaladin-title"], 
                     desc = L["chat-conpaladin-descr"], 
                     type = 'execute', 
                     func = function() ExecuteChatCommand("/chatwho conpaladin") end 
                  }, 
                  conpriest = { 
                     name = L["chat-conpriest-title"], 
                     desc = L["chat-conpriest-descr"], 
                     type = 'execute', 
                     func = function() ExecuteChatCommand("/chatwho conpriest") end 
                  }, 
                  conrogue = { 
                     name = L["chat-conrogue-title"], 
                     desc = L["chat-conrogue-descr"], 
                     type = 'execute', 
                     func = function() ExecuteChatCommand("/chatwho conrogue") end 
                  }, 
                  conshaman = { 
                     name = L["chat-conshaman-title"], 
                     desc = L["chat-conshaman-descr"], 
                     type = 'execute', 
                     func = function() ExecuteChatCommand("/chatwho conshaman") end 
                  },
                  contank = { 
                     name = L["chat-contank-title"], 
                     desc = L["chat-contank-descr"], 
                     type = 'execute', 
                     func = function() ExecuteChatCommand("/chatwho contank") end 
                  },                   
                  conlock = { 
                     name = L["chat-conlock-title"], 
                     desc = L["chat-conlock-descr"], 
                     type = 'execute', 
                     func = function() ExecuteChatCommand("/chatwho conlock") end 
                  }, 
                  conwarrior = { 
                     name = L["chat-conwarrior-title"], 
                     desc = L["chat-conwarrior-descr"], 
                     type = 'execute', 
                     func = function() ExecuteChatCommand("/chatwho conwarrior") end 
                  },
                  conhealer = { 
                     name = L["chat-conhealer-title"], 
                     desc = L["chat-conhealer-descr"], 
                     type = 'execute', 
                     func = function() ExecuteChatCommand("/chatwho conhealer") end 
                  }
               }            
            },
            list = {
               name = L["chat-list-title"], 
               desc = L["chat-list-descr"], 
               type = 'execute', 
               func = function() ExecuteChatCommand("/chatlist") end 
            },
            announce = {
               name = L["chat-announce-title"], 
               desc = L["chat-announce-descr"], 
               type = 'execute', 
               func = function() 
                  SendChatMessage(L["chat-announce-01-msg"], "RAID")
                  SendChatMessage(L["chat-announce-02-msg"], "RAID")
                  SendChatMessage(L["chat-announce-03-msg"], "RAID")
                  SendChatMessage(L["chat-announce-04-msg"], "RAID")
                  SendChatMessage(L["chat-announce-05-msg"], "RAID")
                  SendChatMessage(L["chat-announce-06-msg"], "RAID")
                  SendChatMessage(L["chat-announce-07-msg"], "RAID")
                  SendChatMessage(L["chat-announce-08-msg"], "RAID")
                  SendChatMessage(L["chat-announce-09-msg"], "RAID")
                  SendChatMessage(L["chat-announce-10-msg"], "RAID")
                  SendChatMessage(L["chat-announce-11-msg"], "RAID")
                  SendChatMessage(L["chat-announce-12-msg"], "RAID")
                  SendChatMessage(L["chat-announce-13-msg"], "RAID")
                  SendChatMessage(L["chat-announce-14-msg"], "RAID")
               end 
            }            
         }
      },
      addons = { 
         name = L["mainmenu-addons-title"], 
         type = 'group', 
         desc = L["mainmenu-addons-descr"], 
         args = { 
            ra = {
               name = L["addon-ra-title"],
               type = 'group',
               desc = L["addon-ra-descr"],
               args = {
                  ready = { 
                     name = L["addon-ra-ready-title"], 
                     desc = L["addon-ra-ready-descr"], 
                     type = 'execute', 
                     func = function() ExecuteChatCommand("/raready")  end 
                  },
                  dura = { 
                     name = L["addon-ra-dura-title"], 
                     desc = L["addon-ra-dura-descr"], 
                     type = 'execute', 
                     func = function() ExecuteChatCommand("/radur") end 
                  }, 
                  resist = { 
                     name = L["addon-ra-resist-title"], 
                     desc = L["addon-ra-resist-descr"], 
                     type = 'execute', 
                     func = function() ExecuteChatCommand("/raresist") end 
                  },
                  item = { 
                     name = L["addon-ra-item-title"], 
                     desc = L["addon-ra-item-descr"], 
                     type = 'execute', 
                     func = function()
                        SendChatMessage(L["addon-ra-item-01-msg"], "OFFICER")
                        SendChatMessage(L["addon-ra-item-02-msg"], "OFFICER")
                        SendChatMessage(L["addon-ra-item-03-msg"], "OFFICER")
                        SendChatMessage(L["addon-ra-item-04-msg"], "OFFICER")
                        SendChatMessage(L["addon-ra-item-05-msg"], "OFFICER")
                        SendChatMessage(L["addon-ra-item-06-msg"], "OFFICER")
                        SendChatMessage(L["addon-ra-item-07-msg"], "OFFICER")
                        SendChatMessage(L["addon-ra-item-08-msg"], "OFFICER")
                        SendChatMessage(L["addon-ra-item-09-msg"], "OFFICER")
                        SendChatMessage(L["addon-ra-item-10-msg"], "OFFICER")
                        SendChatMessage(L["addon-ra-item-11-msg"], "OFFICER")                     
                     end 
                  },                  
                  version = { 
                     name = L["addon-ra-version-title"], 
                     desc = L["addon-ra-version-descr"], 
                     type = 'execute', 
                     func = function() ExecuteChatCommand("/raversion")  end 
                  }               
               }
            },
            dbm = {
               name = L["addon-dbm-title"],
               type = 'group',
               desc = L["addon-dbm-descr"],
               args = {
                  timer_bio_02min = { 
                     name = L["addon-dbm-timer-bio-03m-title"], 
                     desc = L["addon-dbm-timer-bio-03m-descr"], 
                     type = 'execute', 
                     func = function() ExecuteChatCommand("/dbm broadcast timer 0h3m "..L["addon-dbm-timer-bio-03m-msg"])  end 
                  }, 
                  timer_bio_05min = { 
                     name = L["addon-dbm-timer-bio-05m-title"], 
                     desc = L["addon-dbm-timer-bio-05m-descr"], 
                     type = 'execute', 
                     func = function() ExecuteChatCommand("/dbm broadcast timer 0h5m "..L["addon-dbm-timer-bio-05m-msg"]) end 
                  }, 
                  timer_raid_begins_05m = { 
                     name = L["addon-dbm-timer-raid-start-05m-title"], 
                     desc = L["addon-dbm-timer-raid-start-05m-descr"], 
                     type = 'execute', 
                     func = function() ExecuteChatCommand("/dbm broadcast timer 0h5m "..L["addon-dbm-timer-raid-start-msg"]) end 
                  },
                  timer_raid_begins_10m = { 
                     name = L["addon-dbm-timer-raid-start-10m-title"], 
                     desc = L["addon-dbm-timer-raid-start-10m-descr"], 
                     type = 'execute', 
                     func = function() ExecuteChatCommand("/dbm broadcast timer 0h10m "..L["addon-dbm-timer-raid-start-msg"]) end 
                  }, 
                  timer_raid_begins_15m = { 
                     name = L["addon-dbm-timer-raid-start-15m-title"], 
                     desc = L["addon-dbm-timer-raid-start-15m-descr"], 
                     type = 'execute', 
                     func = function() ExecuteChatCommand("/dbm broadcast timer 0h15m "..L["addon-dbm-timer-raid-start-msg"]) end 
                  }, 
                  timer_pull_05s_quiet = { 
                     name = L["addon-dbm-timer-pull-quiet-05s-title"], 
                     desc = L["addon-dbm-timer-pull-quiet-05s-descr"], 
                     type = 'execute', 
                     func = function() ExecuteChatCommand("/dbm broadcast timer 0h0m5s "..L["addon-dbm-timer-pull-msg"]) end 
                  }, 
                  timer_pull_10s_quiet = { 
                     name = L["addon-dbm-timer-pull-quiet-10s-title"], 
                     desc = L["addon-dbm-timer-pull-quiet-10s-descr"], 
                     type = 'execute', 
                     func = function() ExecuteChatCommand("/dbm broadcast timer 0h0m10s "..L["addon-dbm-timer-pull-msg"]) end 
                  }, 
                  timer_pull_05s_loud = { 
                     name = L["addon-dbm-timer-pull-loud-05s-title"], 
                     desc = L["addon-dbm-timer-pull-loud-05s-descr"], 
                     type = 'execute', 
                     func = function() ExecuteChatCommand("/dbm pull 5s") end 
                  },             
                  timer_pull_10s_loud = { 
                     name = L["addon-dbm-timer-pull-loud-10s-title"], 
                     desc = L["addon-dbm-timer-pull-loud-10s-descr"], 
                     type = 'execute', 
                     func = function() ExecuteChatCommand("/dbm pull 10s") end 
                  }, 
                  timer_bar_unlock = { 
                     name = L["addon-dbm-unlock-title"], 
                     desc = L["addon-dbm-unlock-descr"], 
                     type = 'execute', 
                     func = function() ExecuteChatCommand("/dbm unlock") end 
                  },
                  stop = { 
                     name = L["addon-dbm-stop-title"], 
                     desc = L["addon-dbm-stop-descr"], 
                      type = 'execute', 
                      func = function() ExecuteChatCommand("/dbm stop") end 
                  },                   
                  version = { 
                     name = L["addon-dbm-version-title"], 
                     desc = L["addon-dbm-version-descr"], 
                      type = 'execute', 
                      func = function() ExecuteChatCommand("/dbm ver") end 
                  }               
               }            
            },
            omen = {
               name = L["addon-omen-title"],
               type = 'group',
               desc = L["addon-omen-descr"],
               args = {
                  version = { 
                     name = L["addon-omen-version-title"], 
                     desc = L["addon-omen-version-descr"], 
                     type = 'execute', 
                     func = function()
                        Omen:VersionCheck(false)
                     end               
                  }               
               }            
            },
            questhelper = {
               name = L["addon-questhelper-title"],
               type = 'group',
               desc = L["addon-questhelper-descr"],
               args = {
                  toggle = { 
                     name = L["addon-questhelper-toggle-title"], 
                     desc = L["addon-questhelper-toggle-descr"], 
                     type = 'execute', 
                     func = function() ExecuteChatCommand("/qh hide") end               
                  }               
               }
            },
            raidbuffstatus = {
               name = L["addon-raidbuffstatus-title"],
               type = 'group',
               desc = L["addon-raidbuffstatus-descr"],
               args = {
                  toggle = { 
                     name = L["addon-raidbuffstatus-toggle-title"], 
                     desc = L["addon-raidbuffstatus-toggle-descr"], 
                     type = 'execute', 
                     func = function() ExecuteChatCommand("/rbs toggle") end               
                  },
                  report = { 
                     name = L["addon-raidbuffstatus-report-title"], 
                     desc = L["addon-raidbuffstatus-report-descr"], 
                     type = 'execute', 
                     func = function() ExecuteChatCommand("/rbs report") end               
                  }                   
               }
            }            
         }
      },
      macro = { 
         name = L["mainmenu-macro-title"], 
         type = 'group', 
         desc = L["mainmenu-macro-descr"], 
         args = { 
            karazhan = { 
               name = L["macro-karazhan-title"], 
               type = 'group', 
               desc = L["macro-karazhan-descr"], 
               args = {
                  curator = { 
                     name = L["macro-karazhan-curator-title"], 
                     type = 'group', 
                     desc = L["macro-karazhan-curator-descr"], 
                     args = {
                        link ={ 
                           name = L["macro-karazhan-curator-link-title"], 
                           desc = L["macro-karazhan-curator-link-descr"], 
                           type = 'execute', 
                           func = function()
                              SendChatMessage(L["macro-karazhan-curator-link-01-msg"], "RAID")
                              SendChatMessage(L["macro-karazhan-curator-link-02-msg"], "RAID")
                              SendChatMessage(L["macro-karazhan-curator-link-03-msg"], "RAID")
                              SendChatMessage(L["macro-karazhan-curator-link-04-msg"], "RAID")
                              SendChatMessage(L["macro-karazhan-curator-link-05-msg"], "RAID")
                              SendChatMessage(L["macro-karazhan-curator-link-06-msg"], "RAID")
                              SendChatMessage(L["macro-karazhan-curator-link-07-msg"], "RAID")
                              SendChatMessage(L["macro-karazhan-curator-link-08-msg"], "RAID")
                              SendChatMessage(L["macro-karazhan-curator-link-09-msg"], "RAID")
                              SendChatMessage(L["macro-karazhan-curator-link-10-msg"], "RAID")
                           end
                        },
                        run ={ 
                           name = L["macro-karazhan-curator-run-title"], 
                           desc = L["macro-karazhan-curator-run-descr"],  
                           type = 'execute', 
                           func = function()
                              ExecuteChatCommand("/target astral flare")
                           end
                        },
                        show ={ 
                           name = L["macro-karazhan-curator-show-title"], 
                           desc = L["macro-karazhan-curator-show-descr"], 
                           type = 'execute', 
                           func = function()
                              SendChatMessage(L["macro-karazhan-curator-show-01-msg"], "RAID")
                              SendChatMessage(L["macro-karazhan-curator-show-02-msg"], "RAID")
                              SendChatMessage(L["macro-karazhan-curator-show-03-msg"], "RAID")
                              SendChatMessage(L["macro-karazhan-curator-show-04-msg"], "RAID")
                              SendChatMessage(L["macro-karazhan-curator-show-05-msg"], "RAID")
                              SendChatMessage(L["macro-karazhan-curator-show-06-msg"], "RAID")
                              SendChatMessage(L["macro-karazhan-curator-show-07-msg"], "RAID")
                              SendChatMessage(L["macro-karazhan-curator-show-08-msg"], "RAID")
                              SendChatMessage(L["macro-karazhan-curator-show-09-msg"], "RAID")
                           end
                        }                        
                     }
                  },
                  illhoof = { 
                     name = L["macro-karazhan-illhoof-title"], 
                     type = 'group', 
                     desc = L["macro-karazhan-illhoof-descr"], 
                     args = {
                        link ={ 
                           name = L["macro-karazhan-illhoof-link-title"], 
                           desc = L["macro-karazhan-illhoof-link-descr"], 
                           type = 'execute', 
                           func = function()
                              SendChatMessage(L["macro-karazhan-illhoof-link-01-msg"], "RAID")
                              SendChatMessage(L["macro-karazhan-illhoof-link-02-msg"], "RAID")
                              SendChatMessage(L["macro-karazhan-illhoof-link-03-msg"], "RAID")
                              SendChatMessage(L["macro-karazhan-illhoof-link-04-msg"], "RAID")
                              SendChatMessage(L["macro-karazhan-illhoof-link-05-msg"], "RAID")
                              SendChatMessage(L["macro-karazhan-illhoof-link-06-msg"], "RAID")
                              SendChatMessage(L["macro-karazhan-illhoof-link-07-msg"], "RAID")
                              SendChatMessage(L["macro-karazhan-illhoof-link-08-msg"], "RAID")
                              SendChatMessage(L["macro-karazhan-illhoof-link-09-msg"], "RAID")
                              SendChatMessage(L["macro-karazhan-illhoof-link-10-msg"], "RAID")
                           end
                        },
                        run ={ 
                           name = L["macro-karazhan-illhoof-run-title"], 
                           desc = L["macro-karazhan-illhoof-run-descr"],  
                           type = 'execute', 
                           func = function()
                              ExecuteChatCommand("/target Demon Chains")
                           end
                        },
                        show ={ 
                           name = L["macro-karazhan-illhoof-show-title"], 
                           desc = L["macro-karazhan-illhoof-show-descr"], 
                           type = 'execute', 
                           func = function()
                              SendChatMessage(L["macro-karazhan-illhoof-show-01-msg"], "RAID")
                              SendChatMessage(L["macro-karazhan-illhoof-show-02-msg"], "RAID")
                              SendChatMessage(L["macro-karazhan-illhoof-show-03-msg"], "RAID")
                              SendChatMessage(L["macro-karazhan-illhoof-show-04-msg"], "RAID")
                              SendChatMessage(L["macro-karazhan-illhoof-show-05-msg"], "RAID")
                              SendChatMessage(L["macro-karazhan-illhoof-show-06-msg"], "RAID")
                              SendChatMessage(L["macro-karazhan-illhoof-show-07-msg"], "RAID")
                              SendChatMessage(L["macro-karazhan-illhoof-show-08-msg"], "RAID")
                              SendChatMessage(L["macro-karazhan-illhoof-show-09-msg"], "RAID")
                           end
                        }                        
                     }
                  }
               }
            },
            ssc = { 
               name = L["macro-ssc-title"], 
               type = 'group', 
               desc = L["macro-ssc-descr"], 
               args = {
                  karathress = { 
                     name = L["macro-ssc-karathress-title"], 
                     type = 'group', 
                     desc = L["macro-ssc-karathress-descr"], 
                     args = {
                        link ={ 
                           name = L["macro-ssc-karathress-link-title"], 
                           desc = L["macro-ssc-karathress-link-descr"], 
                           type = 'execute', 
                           func = function()
                              SendChatMessage(L["macro-ssc-karathress-link-01-msg"], "RAID")
                              SendChatMessage(L["macro-ssc-karathress-link-02-msg"], "RAID")
                              SendChatMessage(L["macro-ssc-karathress-link-03-msg"], "RAID")
                              SendChatMessage(L["macro-ssc-karathress-link-04-msg"], "RAID")
                              SendChatMessage(L["macro-ssc-karathress-link-05-msg"], "RAID")
                              SendChatMessage(L["macro-ssc-karathress-link-06-msg"], "RAID")
                              SendChatMessage(L["macro-ssc-karathress-link-07-msg"], "RAID")
                              SendChatMessage(L["macro-ssc-karathress-link-08-msg"], "RAID")
                              SendChatMessage(L["macro-ssc-karathress-link-09-msg"], "RAID")
                              SendChatMessage(L["macro-ssc-karathress-link-10-msg"], "RAID")
                           end
                        },
                        run ={ 
                           name = L["macro-ssc-karathress-run-title"], 
                           desc = L["macro-ssc-karathress-run-descr"],  
                           type = 'execute', 
                           func = function()
                              ExecuteChatCommand("/target Spitfire Totem")
                           end
                        },
                        show ={ 
                           name = L["macro-ssc-karathress-show-title"], 
                           desc = L["macro-ssc-karathress-show-descr"], 
                           type = 'execute', 
                           func = function()
                              SendChatMessage(L["macro-ssc-karathress-show-01-msg"], "RAID")
                              SendChatMessage(L["macro-ssc-karathress-show-02-msg"], "RAID")
                              SendChatMessage(L["macro-ssc-karathress-show-03-msg"], "RAID")
                              SendChatMessage(L["macro-ssc-karathress-show-04-msg"], "RAID")
                              SendChatMessage(L["macro-ssc-karathress-show-05-msg"], "RAID")
                              SendChatMessage(L["macro-ssc-karathress-show-06-msg"], "RAID")
                              SendChatMessage(L["macro-ssc-karathress-show-07-msg"], "RAID")
                              SendChatMessage(L["macro-ssc-karathress-show-08-msg"], "RAID")
                              SendChatMessage(L["macro-ssc-karathress-show-09-msg"], "RAID")
                           end
                        }                        
                     }
                  },
                  vashj = { 
                     name = L["macro-ssc-vashj-title"], 
                     type = 'group', 
                     desc = L["macro-ssc-vashj-descr"], 
                     args = {
                        link ={ 
                           name = L["macro-ssc-vashj-link-title"], 
                           desc = L["macro-ssc-vashj-link-descr"], 
                           type = 'execute', 
                           func = function()
                              SendChatMessage(L["macro-ssc-vashj-link-01-msg"], "RAID")
                              SendChatMessage(L["macro-ssc-vashj-link-02-msg"], "RAID")
                              SendChatMessage(L["macro-ssc-vashj-link-03-msg"], "RAID")
                              SendChatMessage(L["macro-ssc-vashj-link-04-msg"], "RAID")
                              SendChatMessage(L["macro-ssc-vashj-link-05-msg"], "RAID")
                              SendChatMessage(L["macro-ssc-vashj-link-06-msg"], "RAID")
                              SendChatMessage(L["macro-ssc-vashj-link-07-msg"], "RAID")
                              SendChatMessage(L["macro-ssc-vashj-link-08-msg"], "RAID")
                              SendChatMessage(L["macro-ssc-vashj-link-09-msg"], "RAID")
                              SendChatMessage(L["macro-ssc-vashj-link-10-msg"], "RAID")
                           end
                        },
                        run ={ 
                           name = L["macro-ssc-vashj-run-title"], 
                           desc = L["macro-ssc-vashj-run-descr"],  
                           type = 'execute', 
                           func = function()
                              ExecuteChatCommand("/use Tainted Core")
                              ExecuteChatCommand("/y <------- TAINTED CORE TO: %t ! ! !")
                              ExecuteChatCommand("/s <------- TAINTED CORE TO: %t ! ! !")
                              SendChatMessage("!!! YOU HAVE THE CORE !!!", "WHISPER", nil, UnitName("target"))
                           end
                        },
                        show ={ 
                           name = L["macro-ssc-vashj-show-title"], 
                           desc = L["macro-ssc-vashj-show-descr"], 
                           type = 'execute', 
                           func = function()
                              SendChatMessage(L["macro-ssc-vashj-show-01-msg"], "RAID")
                              SendChatMessage(L["macro-ssc-vashj-show-02-msg"], "RAID")
                              SendChatMessage(L["macro-ssc-vashj-show-03-msg"], "RAID")
                              SendChatMessage(L["macro-ssc-vashj-show-04-msg"], "RAID")
                              SendChatMessage(L["macro-ssc-vashj-show-05-msg"], "RAID")
                              SendChatMessage(L["macro-ssc-vashj-show-06-msg"], "RAID")
                              SendChatMessage(L["macro-ssc-vashj-show-07-msg"], "RAID")
                              SendChatMessage(L["macro-ssc-vashj-show-08-msg"], "RAID")
                              SendChatMessage(L["macro-ssc-vashj-show-09-msg"], "RAID")
                              SendChatMessage(L["macro-ssc-vashj-show-10-msg"], "RAID")
                              SendChatMessage(L["macro-ssc-vashj-show-11-msg"], "RAID")
                              SendChatMessage(L["macro-ssc-vashj-show-12-msg"], "RAID")
                           end
                        }                        
                     }
                  }
               }
            },
            bt = { 
               name = L["macro-bt-title"], 
               type = 'group', 
               desc = L["macro-bt-descr"], 
               args = {
                  najentus_spine = { 
                     name = L["macro-bt-najentus-spine-title"], 
                     type = 'group', 
                     desc = L["macro-bt-najentus-spine-descr"], 
                     args = {
                        link ={ 
                           name = L["macro-bt-najentus-spine-link-title"], 
                           desc = L["macro-bt-najentus-spine-link-descr"], 
                           type = 'execute', 
                           func = function()
                              SendChatMessage(L["macro-bt-najentus-spine-link-01-msg"], "RAID")
                              SendChatMessage(L["macro-bt-najentus-spine-link-02-msg"], "RAID")
                              SendChatMessage(L["macro-bt-najentus-spine-link-03-msg"], "RAID")
                              SendChatMessage(L["macro-bt-najentus-spine-link-04-msg"], "RAID")
                              SendChatMessage(L["macro-bt-najentus-spine-link-05-msg"], "RAID")
                              SendChatMessage(L["macro-bt-najentus-spine-link-06-msg"], "RAID")
                              SendChatMessage(L["macro-bt-najentus-spine-link-07-msg"], "RAID")
                              SendChatMessage(L["macro-bt-najentus-spine-link-08-msg"], "RAID")
                              SendChatMessage(L["macro-bt-najentus-spine-link-09-msg"], "RAID")
                              SendChatMessage(L["macro-bt-najentus-spine-link-10-msg"], "RAID")
                           end
                        },
                        run ={ 
                           name = L["macro-bt-najentus-spine-run-title"], 
                           desc = L["macro-bt-najentus-spine-run-descr"],  
                           type = 'execute', 
                           func = function()
                              ExecuteChatCommand("/use Naj'entus Spine")
                           end
                        },
                        show ={ 
                           name = L["macro-bt-najentus-spine-show-title"], 
                           desc = L["macro-bt-najentus-spine-show-descr"], 
                           type = 'execute', 
                           func = function()
                              SendChatMessage(L["macro-bt-najentus-spine-show-01-msg"], "RAID")
                              SendChatMessage(L["macro-bt-najentus-spine-show-02-msg"], "RAID")
                              SendChatMessage(L["macro-bt-najentus-spine-show-03-msg"], "RAID")
                              SendChatMessage(L["macro-bt-najentus-spine-show-04-msg"], "RAID")
                              SendChatMessage(L["macro-bt-najentus-spine-show-05-msg"], "RAID")
                              SendChatMessage(L["macro-bt-najentus-spine-show-06-msg"], "RAID")
                              SendChatMessage(L["macro-bt-najentus-spine-show-07-msg"], "RAID")
                              SendChatMessage(L["macro-bt-najentus-spine-show-08-msg"], "RAID")
                              SendChatMessage(L["macro-bt-najentus-spine-show-09-msg"], "RAID")
                           end
                        }                        
                     }
                  },
                  najentus_hp = { 
                     name = L["macro-bt-najentus-hp-title"], 
                     type = 'group', 
                     desc = L["macro-bt-najentus-hp-descr"], 
                     args = {
                        link ={ 
                           name = L["macro-bt-najentus-hp-link-title"], 
                           desc = L["macro-bt-najentus-hp-link-descr"], 
                           type = 'execute', 
                           func = function()
                              SendChatMessage(L["macro-bt-najentus-hp-link-01-msg"], "RAID")
                              SendChatMessage(L["macro-bt-najentus-hp-link-02-msg"], "RAID")
                              SendChatMessage(L["macro-bt-najentus-hp-link-03-msg"], "RAID")
                              SendChatMessage(L["macro-bt-najentus-hp-link-04-msg"], "RAID")
                              SendChatMessage(L["macro-bt-najentus-hp-link-05-msg"], "RAID")
                              SendChatMessage(L["macro-bt-najentus-hp-link-06-msg"], "RAID")
                              SendChatMessage(L["macro-bt-najentus-hp-link-07-msg"], "RAID")
                              SendChatMessage(L["macro-bt-najentus-hp-link-08-msg"], "RAID")
                              SendChatMessage(L["macro-bt-najentus-hp-link-09-msg"], "RAID")
                              SendChatMessage(L["macro-bt-najentus-hp-link-10-msg"], "RAID")
                           end
                        },
                        run ={ 
                           name = L["macro-bt-najentus-hp-run-title"], 
                           desc = L["macro-bt-najentus-hp-run-descr"],  
                           type = 'execute', 
                           func = function()
                              for i = 1, 40 do
                                local u = "raid"..i;
                                local hp = UnitHealthMax(u);
                                local _, _, grp = GetRaidRosterInfo(i);
                                if UnitExists(u) and hp < 9500 and grp <= 5 then
                                  ChatFrame1:AddMessage(UnitName(u)..": "..hp.." HP");
                                end
                              end 
                           end
                        },
                        show ={ 
                           name = L["macro-bt-najentus-hp-show-title"], 
                           desc = L["macro-bt-najentus-hp-show-descr"], 
                           type = 'execute', 
                           func = function()
                              SendChatMessage(L["macro-bt-najentus-hp-show-01-msg"], "RAID")
                              SendChatMessage(L["macro-bt-najentus-hp-show-02-msg"], "RAID")
                              SendChatMessage(L["macro-bt-najentus-hp-show-03-msg"], "RAID")
                              SendChatMessage(L["macro-bt-najentus-hp-show-04-msg"], "RAID")
                              SendChatMessage(L["macro-bt-najentus-hp-show-05-msg"], "RAID")
                              SendChatMessage(L["macro-bt-najentus-hp-show-06-msg"], "RAID")
                              SendChatMessage(L["macro-bt-najentus-hp-show-07-msg"], "RAID")
                              SendChatMessage(L["macro-bt-najentus-hp-show-08-msg"], "RAID")
                              SendChatMessage(L["macro-bt-najentus-hp-show-09-msg"], "RAID")
                              SendChatMessage(L["macro-bt-najentus-hp-show-10-msg"], "RAID")                              
                              SendChatMessage(L["macro-bt-najentus-hp-show-11-msg"], "RAID")
                              SendChatMessage(L["macro-bt-najentus-hp-show-12-msg"], "RAID")
                              SendChatMessage(L["macro-bt-najentus-hp-show-13-msg"], "RAID")
                              SendChatMessage(L["macro-bt-najentus-hp-show-14-msg"], "RAID")
                              SendChatMessage(L["macro-bt-najentus-hp-show-15-msg"], "RAID")
                              SendChatMessage(L["macro-bt-najentus-hp-show-16-msg"], "RAID")
                              SendChatMessage(L["macro-bt-najentus-hp-show-17-msg"], "RAID")                              
                           end
                        }                        
                     }
                  }                  
               }
            }
         }         
      },
      tools = {
         name = L["mainmenu-tools-title"], 
         type = 'group', 
         desc = L["mainmenu-tools-descr"], 
         args = {
            search = {
              name = L["tools-searchtarget-title"],
              desc = L["tools-searchtarget-descr"],
              type = 'group',
              args = {
                set = {
                   name  = L["tools-searchtarget-set-title"],
                   desc  = L["tools-searchtarget-set-descr"],
                   type  = 'text',
                   usage = L["tools-searchtarget-set-usage"],
                   get   = function() return ConvergeFu.db.profile.searchTarget end,
                   set   = function(newValue) ConvergeFu.db.profile.searchTarget = newValue end,
                },
                findall = {
                   name = L["tools-searchtarget-findall-title"],
                   desc = L["tools-searchtarget-findall-descr"],
                   type = 'execute',
                   func = function()
                      ConvergeFu:ListAssociatedCharacters(ConvergeFu.db.profile.searchTarget,"Officer");
                   end
                },
                findonline = {
                   name = L["tools-searchtarget-findonline-title"],
                   desc = L["tools-searchtarget-findonline-descr"],
                   type = 'execute',
                   func = function()
                      SendChatMessage(ConvergeFu:FindPlayerByCharacterName(ConvergeFu.db.profile.searchTarget), "Officer")
                   end
                }
              }
            },
            misc = {
              name = L["tools-misc-title"],
              desc = L["tools-misc-descr"],
              type = 'group',
              args = {
                rogue_avoidance = {
                   name  = L["tools-misc-rogueav-title"],
                   desc  = L["tools-misc-rogueav-descr"],
                   type = 'execute',
                   func = function()
                      ConvergeFu:ShowAvoidanceForLevel70Rogues()   
                   end
                }
              }
            },            
            hero = {
              name = L["tools-hero-title"],
              desc = L["tools-hero-descr"],
              type = 'group',
              args = {
                listall = {
                   name = L["tools-hero-listall-title"],
                   desc = L["tools-hero-listall-descr"],
                   type = 'execute',
                   func = function()
                      ConvergeFu:ListAllHeroes("Officer")
                   end
                },
                announce = {
                   name = L["tools-hero-announce-title"],
                   desc = L["tools-hero-announce-descr"],
                   type = 'execute',
                   func = function()
                      ConvergeFu:AnnounceRankChanges("GUILD")
                   end
                },
                demoteall = {
                   name = L["tools-hero-demoteall-title"],
                   desc = L["tools-hero-demoteall-descr"],
                   type = 'execute',
                   func = function()
                      ConvergeFu:DemoteAllHeroes()
                   end
                },
                setallalts = {
                   name = L["tools-hero-setallalts-title"],
                   desc = L["tools-hero-setallalts-descr"],
                   type = 'execute',
                   func = function()
                      ConvergeFu:SetAllAltCharacterRanks()
                   end
                }                
              }
            }
         }
      }
   } 
} 

ConvergeFu:RegisterChatCommand({"/confu"}, ConvergeFu.consoleOptions);
ConvergeFu.OnMenuRequest = ConvergeFu.consoleOptions; 

-- ============================================================================
-- == OnEnable()                                                             ==
-- ==                                                                        ==
-- == This function is part of the provided API.                             ==
-- ============================================================================

function ConvergeFu:OnEnable()

end 

-- ============================================================================
-- == OnTextUpdate()                                                         ==
-- ==                                                                        ==
-- == This function is part of the provided API.                             ==
-- ============================================================================

function ConvergeFu:OnTextUpdate() 
   if (self:IsTextShown()) then 
      self:ShowText(); 
      self:SetText("|cffffffff"..L["labelName"].."|r"); 
   else 
      self:HideText(); 
   end 
end 

-- ============================================================================
-- == OnTooltipUpdate()                                                      ==
-- ==                                                                        ==
-- == This function is part of the provided API. It is called when the user  ==
-- == action requires the tooltip to be displayed.                           ==
-- ============================================================================

function ConvergeFu:OnTooltipUpdate() 

   cat = Tablet:AddCategory(
     'columns', 1,
     'text', L["tablet-cat-01-title"],
     'textR', 1, 'textG', 1, 'textB', 0
   )
   cat:AddLine('text', L["tablet-cat-01-line-01"], 'textR', 1, 'textG', 1, 'textB', 1)
   cat:AddLine('text', L["tablet-cat-01-line-02"], 'textR', 1, 'textG', 1, 'textB', 1)
   cat:AddLine('text', L["tablet-cat-01-line-03"], 'textR', 1, 'textG', 1, 'textB', 1)
   cat:AddLine('text', L["tablet-cat-01-line-04"], 'textR', 1, 'textG', 1, 'textB', 1)
   cat:AddLine('text', L["tablet-cat-01-line-05"], 'textR', 1, 'textG', 1, 'textB', 1)
   cat:AddLine('text', L["tablet-cat-01-line-06"], 'textR', 1, 'textG', 1, 'textB', 1)
   cat:AddLine('text', L["tablet-cat-01-line-07"], 'textR', 1, 'textG', 1, 'textB', 1)
   cat:AddLine('text', L["tablet-cat-01-line-08"], 'textR', 1, 'textG', 1, 'textB', 1)
   cat:AddLine('text', L["tablet-cat-01-line-09"], 'textR', 1, 'textG', 1, 'textB', 1)
   cat:AddLine('text', L["tablet-cat-01-line-10"], 'textR', 1, 'textG', 1, 'textB', 1)
   cat:AddLine('text', L["tablet-cat-01-line-11"], 'textR', 1, 'textG', 1, 'textB', 1)
   
   cat = Tablet:AddCategory(
     'columns', 1,
     'text', L["tablet-cat-02-title"],
     'textR', 1, 'textG', 1, 'textB', 0
   )  
   cat:AddLine('text', L["tablet-cat-02-line-01"], 'textR', 1, 'textG', 1, 'textB', 1)
   cat:AddLine('text', L["tablet-cat-02-line-02"]..ConvergeFu:GetNumberOfGuildOfficers()..L["tablet-cat-02-line-03"], 'textR', 1, 'textG', 1, 'textB', 1)
   cat:AddLine('text', L["tablet-cat-02-line-04"], 'textR', 1, 'textG', 1, 'textB', 1)
   
   ConvergeFu:GetGuildOfficerNamesForTooltip(cat)
   
   cat = Tablet:AddCategory(
     'columns', 1,
     'text', L["tablet-cat-03-title"],
     'textR', 1, 'textG', 1, 'textB', 0
   )    
   cat:AddLine('text', L["tablet-cat-03-line-01"]..UnitName("player"), 'textR', 1, 'textG', 1, 'textB', 1)
   cat:AddLine('text', L["tablet-cat-03-line-02"]..ConvergeFu:GetGuildName(), 'textR', 1, 'textG', 1, 'textB', 1)
   cat:AddLine('text', L["tablet-cat-03-line-03"]..ConvergeFu:GetGuildRankName(), 'textR', 1, 'textG', 1, 'textB', 1)
      
   Tablet:SetHint(L["tabletHint"]); 
end 

-- ============================================================================
-- == OnClick()                                                              ==
-- ==                                                                        ==
-- == This function is part of the provided API. It is called when the user  ==
-- == clicks on the addon's icon.                                            ==
-- ==                                                                        ==
-- == <click>           : Toggle RaidBuffStatus Dashboard.                   ==
-- == <alt><click>      : Generate a RaidBuffStatus report.                  ==
-- == <ctrl><click>     : <currently nothing>                                ==
-- == <ctrl><alt><click : <currently nothing>                                ==
-- ============================================================================

function ConvergeFu:OnClick()
  if IsAltKeyDown() and IsControlKeyDown() then
    -- Do nothing.
  elseif IsAltKeyDown() then
    ExecuteChatCommand("/rbs report")
    return
  elseif IsControlKeyDown() then
    -- Do nothing.
  end
  ExecuteChatCommand("/rbs toggle")  
end

-- ============================================================================
-- == ExecuteChatCommand(arg)                                                ==
-- ==                                                                        ==
-- == This function attempts to execute the supplied argument as though it   ==
-- == were a command entered by the user in the chat window.                 ==
-- ============================================================================

function ExecuteChatCommand(arg)
  if( not DEFAULT_CHAT_FRAME ) then return end
  DEFAULT_CHAT_FRAME.editBox:SetText(arg);
  ChatEdit_SendText(DEFAULT_CHAT_FRAME.editBox);
end

-- ============================================================================
-- == GetGuildName()                                                         ==
-- ==                                                                        ==
-- == This function retrieves the Guild name of the user, if they are in a   ==
-- == guild, otherwise it returns "Unguilded".                               ==
-- ============================================================================

function ConvergeFu:GetGuildName()
  if IsInGuild() then
    local guildName, guildRankName, guildRankIndex = GetGuildInfo("player")
    return guildName 
  else
    return L["common-guildname-unguilded"]
  end
end

-- ============================================================================
-- == GetGuildRankName()                                                     ==
-- ==                                                                        ==
-- == This function retrieves the rank name of the user, if they are in a    ==
-- == guild, otherwise it returns "Unranked".                                ==
-- ============================================================================
 
function ConvergeFu:GetGuildRankName()
  if IsInGuild() then
    local guildName, guildRankName, guildRankIndex = GetGuildInfo("player")
    return guildRankName  
  else
    return L["common-rankname-unguilded"]
  end
end 

-- ============================================================================
-- == GetNumberOfGuildOfficers()                                             ==
-- ==                                                                        ==
-- == This function looks for characters holding the Officer rank and then   ==
-- == simply performs a count to determine how many such characters there    ==
-- == are.                                                                   ==
-- ============================================================================

function ConvergeFu:GetNumberOfGuildOfficers()
  local numOfficers = 0
  if IsInGuild() then
    for index = 1, (GetNumGuildMembers(true)) do
      name, rank, rankIndex, level, class, zone, note, officernote, online, status = GetGuildRosterInfo(index);
    
      if rank == L["common-rankname-officer"] or rank == L["common-rankname-gm"] or rankIndex == 0 or rankIndex == 1 then
        numOfficers = numOfficers + 1
      end
    end
  end
  return numOfficers
end

-- ============================================================================
-- == GetGuildOfficerNamesForTooltip(cat)                                    ==
-- ==                                                                        ==
-- == This function looks for characters holding the Officer rank and then   ==
-- == adds a line to the provided "Category" object, which simply contains   ==
-- == that officer's name.                                                   ==
-- ============================================================================

function ConvergeFu:GetGuildOfficerNamesForTooltip(cat)
  if IsInGuild() then
    for index = 1, (GetNumGuildMembers(true)) do
      name, rank, rankIndex, level, class, zone, note, officernote, online, status = GetGuildRosterInfo(index);
    
      if rank == L["common-rankname-officer"] or rank == L["common-rankname-gm"] or rankIndex == 0 or rankIndex == 1 then
        cat:AddLine('text', ConvergeFu:FindPlayerByCharacterName(name), 'textR', 1, 'textG', 0, 'textB', 1)
      end
    end 
  end
end

-- ============================================================================
-- == FindPlayerByCharacterName(mainCharacterName)                           ==
-- ==                                                                        ==
-- == This function takes a character name as input and searchs through the  ==
-- == guild's roster, looking to find if the player that owns that character ==
-- == is currently online, either on the character named or on an alt        ==
-- == character associated with the character named.                         ==
-- ==                                                                        ==
-- == This assumes that for a given main character, all associated alt       ==
-- == characters will have the main character's name in the public note      ==
-- == field.                                                                 ==
-- ============================================================================

function ConvergeFu:FindPlayerByCharacterName(characterName)

  characterNameToReturn = characterName.." (Offline)"
  
  totalNumberOfGuildMembers = GetNumGuildMembers(true)
  
  for index=1, totalNumberOfGuildMembers, 1 do
    name, rank, rankIndex, level, class, zone, note, officernote, online, status = GetGuildRosterInfo(index)
    if name == characterName and online == 1 then
      characterNameToReturn = characterName
    elseif note == characterName and online == 1 then
      characterNameToReturn = name.." (aka: "..characterName..")"
    end
  end
  
  return characterNameToReturn

end

-- ============================================================================
-- == ListAssociatedCharacters(characterName)                                ==
-- ==                                                                        ==
-- == This function outputs a list of characters associated with a single    ==
-- == player. It takes as input the name of any character associated with    ==
-- == the player who is on the guild roster and it then searches the roster  ==
-- == to find the main and alt characters belonging to the same player.      ==
-- ============================================================================

function ConvergeFu:ListAssociatedCharacters(characterName,channelName)

  strMainCharName = "";

  for index = 1, (GetNumGuildMembers(true)) do
    name, rank, rankIndex, level, class, zone, note, officernote, online, status = GetGuildRosterInfo(index);
    if name == characterName then
      SendChatMessage("Main: "..name, channelName)
    end
  end
  
  for index = 1, (GetNumGuildMembers(true)) do
    name, rank, rankIndex, level, class, zone, note, officernote, online, status = GetGuildRosterInfo(index);
    if string.match (note, characterName) ~= nil then
      SendChatMessage("Alt : "..name, channelName)
    end
  end  
end

-- ============================================================================
-- == ListAllHeroes()                                                        ==
-- ==                                                                        ==
-- == This function iterates through the roster and lists all characters     ==
-- == holding the "Hero Member" rank.                                        ==
-- ============================================================================

function ConvergeFu:ListAllHeroes(channelName)

  SendChatMessage(L["tools-hero-listall-01-msg"], channelName)
  SendChatMessage(L["tools-hero-listall-02-msg"], channelName)
  SendChatMessage(L["tools-hero-listall-03-msg"], channelName)
  
  for index = 1, (GetNumGuildMembers(true)) do
    name, rank, rankIndex, level, class, zone, note, officernote, online, status = GetGuildRosterInfo(index);

    if rank == L["common-rankname-member-hero"] then
      SendChatMessage(" "..name, channelName)
    end
  end
  
  SendChatMessage(L["tools-hero-listall-04-msg"], channelName)
end

-- ============================================================================
-- == DemoteAllHeroes()                                                      ==
-- ==                                                                        ==
-- == This function iterates through the roster and demotes all characters   ==
-- == holding either the "Hero Member" or "Alt-Hero" ranks in preparation    ==
-- == for the month-end changes.                                             ==
-- ==                                                                        ==
-- == It is assumed that the normal member and alt ranks lie one level below ==
-- == the hero versions respectively.                                        ==
-- ============================================================================

function ConvergeFu:DemoteAllHeroes()

  for index = 1, (GetNumGuildMembers(true)) do
    name, rank, rankIndex, level, class, zone, note, officernote, online, status = GetGuildRosterInfo(index);

    if rank == L["common-rankname-member-hero"] then
      GuildDemote(name)
    elseif rank == L["common-rankname-alt-hero"] then
      GuildDemote(name)
    end
  end
end

-- ============================================================================
-- == PromoteAltsOfHeroes()                                                  ==
-- ==                                                                        ==
-- == This function iterates through the roster and promotes all characters  ==
-- == holding the "Alt-Normal" rank that belong to main characters holding   ==
-- == the "Hero Member" rank.                                                ==
-- ==                                                                        ==
-- == It is assumed that the normal member and alt ranks lie one level below ==
-- == the hero versions respectively.                                        ==
-- ============================================================================

function ConvergeFu:PromoteAltsOfHeroes()
  for index = 1, (GetNumGuildMembers(true)) do
    name, rank, rankIndex, level, class, zone, note, officernote, online, status = GetGuildRosterInfo(index);

    if rank == L["common-rankname-member-hero"] then
      for index2 = 1, (GetNumGuildMembers(true)) do
        name2, rank2, rankIndex2, level2, class2, zone2, note2, officernote2, online2, status2 = GetGuildRosterInfo(index2);
        
        if note2 == name then
          if rank2 == L["common-rankname-alt-normal"] then
            GuildPromote(name2)
          end
        end
      end
    end
  end
end

-- ============================================================================
-- == SetCharacterRank(characterName, targetRankName, channelName)           ==
-- ==                                                                        ==
-- == This function sets the rank of a named character to a selected rank    ==
-- == by first demoting it all the way down to the lowest guild rank before  ==
-- == promoting it iteratively back up to the desired rank.                  ==
-- ==                                                                        ==
-- == This function assumes that the 'benched' rank is the lowest rank. The  ==
-- == channelName is simply used for directing update messages.              ==
-- ============================================================================

function ConvergeFu:SetCharacterRank(characterName, targetRankName, channelName)
  for index = 1, (GetNumGuildMembers(true)) do
    name, rank, rankIndex, level, class, zone, note, officernote, online, status = GetGuildRosterInfo(index);
    
    if name == characterName then
      if rank ~= targetRankName then

        messageText = L["common-setrank-msg-01"]
                   .. name
                   .. L["common-setrank-msg-02"]
                   .. rank
                   .. L["common-setrank-msg-03"] 
                   .. targetRankName
                   .. L["common-setrank-msg-04"]
                   
        ConvergeFu:SendChatMessage(messageText, channelName)
        
        name2, rank2, rankIndex2, level2, class2, zone2, note2, officernote2, online2, status2 = GetGuildRosterInfo(index);
        
        while rank2 ~= L["common-rankname-benched"] do
          GuildDemote(name)
          name2, rank2, rankIndex2, level2, class2, zone2, note2, officernote2, online2, status2 = GetGuildRosterInfo(index);
        end

        name3, rank3, rankIndex3, level3, class3, zone3, note3, officernote3, online3, status3 = GetGuildRosterInfo(index);

        while rank3 ~= targetRankName do
          GuildPromote(name)
          name3, rank3, rankIndex3, level3, class3, zone3, note3, officernote3, online3, status3 = GetGuildRosterInfo(index);
        end
      end
    end
  end
end

-- ============================================================================
-- == GetCharacterRank(characterName)                                        ==
-- ==                                                                        ==
-- == This function gets the rank of a named character.                      ==
-- ============================================================================

function ConvergeFu:GetCharacterRank(characterName)
  characterRank = L["common-rankname-benched"]

  for index = 1, (GetNumGuildMembers(true)) do
    name, rank, rankIndex, level, class, zone, note, officernote, online, status = GetGuildRosterInfo(index);
    
    if name == characterName then
      characterRank = rank
    end
  end  
  
  return characterRank
end

-- ============================================================================
-- == GetCorrespondingAltRank(rankName)                                      ==
-- ==                                                                        ==
-- == This function gets the name of the alt rank that corresponds to the    ==
-- == supplied rank name, which is assumed to be the rank of a 'main'        ==
-- == character. If it cannot find the corresponding rank, it returns the    ==
-- == name of the lowest guild rank (the 'benched' rank typically) instead.  ==
-- ============================================================================

function ConvergeFu:GetCorrespondingAltRank(rankName)
  correspondingAltRank = L["common-rankname-benched"] 

  if rankName == L["common-rankname-gm"] then
    correspondingAltRank = L["common-rankname-alt-officer"]
    
  elseif rankName == L["common-rankname-officer"] then
    correspondingAltRank = L["common-rankname-alt-officer"]
    
  elseif rankName == L["common-rankname-member-hero"] then
    correspondingAltRank = L["common-rankname-alt-hero"]
    
  elseif rankName == L["common-rankname-member-normal"] then
    correspondingAltRank = L["common-rankname-alt-normal"]
    
  elseif rankName == L["common-rankname-member-trial"] then
    correspondingAltRank = L["common-rankname-alt-trial"]
  end
  
  return correspondingAltRank
end

-- ============================================================================
-- == IsAltRankedCharacter(characterName)                                    ==
-- ==                                                                        ==
-- == This function determines whether the named character is an alt ranked  ==
-- == character and returns true if it is, otherwise it returns false.       ==
-- ============================================================================

function ConvergeFu:IsAltRankedCharacter(characterName)

  for index = 1, (GetNumGuildMembers(true)) do
    name, rank, rankIndex, level, class, zone, note, officernote, online, status = GetGuildRosterInfo(index);

    if name == characterName then
      if rank == L["common-rankname-alt-officer"]
         or rank == L["common-rankname-alt-hero"]
         or rank == L["common-rankname-alt-normal"]
         or rank == L["common-rankname-alt-trial"] then
        return true
      end
    end
    return false
  end   
end

-- ============================================================================
-- == SetAllAltCharacterRanks()                                              ==
-- ==                                                                        ==
-- == This function attempts to set the rank of all alt characters correctly ==
-- == to the alt-rank corresponding to the rank of the main character with   ==
-- == which they are associated.                                             ==
-- ============================================================================

function ConvergeFu:SetAllAltCharacterRanks()

  for index = 1, (GetNumGuildMembers(true)) do
    name, rank, rankIndex, level, class, zone, note, officernote, online, status = GetGuildRosterInfo(index);

    if ConvergeFu:IsAltRankedCharacter(name) then
      mainCharacterRank = ConvergeFu:GetCharacterRank(note)
      altCharacterRank  = ConvergeFu:GetCorrespondingAltRank(mainCharacterRank)
      ConvergeFu:SetCharacterRank(name, altCharacterRank, "Officer")    
    end
  end   
end

-- ============================================================================
-- == SendChatMessage(messageText, channelName)                              ==
-- ==                                                                        ==
-- == This function is ostensibly just a wrapper to the normal               ==
-- == SendChatMessage function with the additional utility that the          ==
-- == channel name can be set to "NULL" and the function will not output the ==
-- == message. This allows functions within ConvergeFu to attempt to pass    ==
-- == out messages whilst allowing the calling code to determine whether or  ==
-- == not those messages should be displayed by either passing in a valid    ==
-- == value for the 'channelName' parameter or 'NULL' if they want to mute   ==
-- == all output messages.                                                   ==
-- ============================================================================

function ConvergeFu:SendChatMessage(messageText, channelName)
  if channelName ~= "NULL" then
    SendChatMessage(messageText, channelName)
  end
end

-- ============================================================================
-- == ShowAvoidanceForLevel70Rogues()                                        ==
-- ==                                                                        ==
-- == Simply outputs some text to the default chat frame listing the         ==
-- == player's current 'avoidance' level. This version is configured for use ==
-- == by rogues and will not produce accurate values for other classes.      ==
-- ============================================================================

function ConvergeFu:ShowAvoidanceForLevel70Rogues()
  DEFAULT_CHAT_FRAME:AddMessage(L["tools-misc-rogueav-01-msg"],0.8,0.8,1)
  DEFAULT_CHAT_FRAME:AddMessage(GetDodgeChance()+GetParryChance()+12+(GetCombatRating(CR_DEFENSE_SKILL)*150/355)*0.04,1,0.5,0)
end

-- ============================================================================
-- == AnnounceRankChanges(channelName)                                       ==
-- ==                                                                        ==
-- == This function outputs an announcement in the channel specified by the  ==
-- == channelName parameter (typically "Guild") to inform players that the   ==
-- == month end processing to update the players that are awarded the hero   ==
-- == status is about to begin.                                              ==
-- ============================================================================

function ConvergeFu:AnnounceRankChanges(channelName)
  SendChatMessage(L["common-rankchange-announce-01-msg"], channelName)
  SendChatMessage(L["common-rankchange-announce-02-msg"], channelName)
  SendChatMessage(L["common-rankchange-announce-03-msg"], channelName)
  SendChatMessage(L["common-rankchange-announce-04-msg"], channelName)
  SendChatMessage(L["common-rankchange-announce-05-msg"], channelName)
  SendChatMessage(L["common-rankchange-announce-06-msg"], channelName)
  SendChatMessage(L["common-rankchange-announce-07-msg"], channelName)
  SendChatMessage(L["common-rankchange-announce-08-msg"], channelName)
  SendChatMessage(L["common-rankchange-announce-09-msg"], channelName)
  SendChatMessage(L["common-rankchange-announce-10-msg"], channelName)
  SendChatMessage(L["common-rankchange-announce-11-msg"], channelName)
  SendChatMessage(L["common-rankchange-announce-12-msg"], channelName)
  SendChatMessage(L["common-rankchange-announce-13-msg"], channelName)
end

-- ============================================================================
-- == AnnounceRaidInvite(officerName,channelName)                            ==
-- ==                                                                        ==
-- == This function outputs an announcement in the channel specified by the  ==
-- == channelName parameter (typically "Guild") to inform players that the   ==
-- == invitation period for the next raid has begun and that players should  ==
-- == whisper the officer indicated to get an invitation to the raid.        ==
-- ============================================================================

function ConvergeFu:AnnounceRaidInvite(officerName,channelName)

  strOfficerName = ConvergeFu:FindPlayerByCharacterName(officerName)
  
  strGMOTD = L["common-motd-raidinvites-01"]
          .. strOfficerName
          .. L["common-motd-raidinvites-02"]
          
  GuildSetMOTD(strGMOTD)
  
  SendChatMessage(L["ann-guild-raid-invite-01-msg"], channelName)
  SendChatMessage(L["ann-guild-raid-invite-02-msg"], channelName)
  SendChatMessage(L["ann-guild-raid-invite-03-msg"], channelName)
  SendChatMessage(L["ann-guild-raid-invite-04-msg"], channelName)
  SendChatMessage(L["ann-guild-raid-invite-05-msg"], channelName)
  SendChatMessage(L["ann-guild-raid-invite-06-msg"], channelName)
          
  SendChatMessage(" "..strOfficerName, channelName)

  SendChatMessage(L["ann-guild-raid-invite-07-msg"], channelName)
  SendChatMessage(L["ann-guild-raid-invite-08-msg"], channelName)
  SendChatMessage(L["ann-guild-raid-invite-09-msg"], channelName)
  SendChatMessage(L["ann-guild-raid-invite-10-msg"], channelName)
end

-- ============================================================================
-- == AnnounceWaitList(officerName,channelName)                              ==
-- ==                                                                        ==
-- == This function outputs an announcement in the channel specified by the  ==
-- == channelName parameter (typically "Guild") to inform players that the   ==
-- == invitation period for the next raid has closed but that the wait list  ==
-- == is now open and that they should whisper a named officer if they wish  ==
-- == to join the raid's wait list (queue).                                  ==
-- ============================================================================

function ConvergeFu:AnnounceWaitList(officerName,channelName)
  
  strOfficerName = ConvergeFu:FindPlayerByCharacterName(officerName)
  
  strGMOTD = L["common-motd-raidinprogress-01"]
          .. strOfficerName
          .. L["common-motd-raidinprogress-02"]
          
  GuildSetMOTD(strGMOTD)
  
  SendChatMessage(L["ann-guild-wait-list-01-msg"], channelName)
  SendChatMessage(L["ann-guild-wait-list-02-msg"], channelName)
  SendChatMessage(L["ann-guild-wait-list-03-msg"], channelName)
  SendChatMessage(L["ann-guild-wait-list-04-msg"], channelName)
  SendChatMessage(L["ann-guild-wait-list-05-msg"], channelName)
  SendChatMessage(L["ann-guild-wait-list-06-msg"], channelName)
  SendChatMessage(L["ann-guild-wait-list-07-msg"], channelName)
  SendChatMessage(L["ann-guild-wait-list-08-msg"], channelName)
  SendChatMessage(L["ann-guild-wait-list-09-msg"], channelName)
  SendChatMessage(L["ann-guild-wait-list-10-msg"], channelName)
  SendChatMessage(L["ann-guild-wait-list-11-msg"], channelName)
  SendChatMessage(L["ann-guild-wait-list-12-msg"], channelName)
  SendChatMessage(L["ann-guild-wait-list-13-msg"], channelName)
  SendChatMessage(L["ann-guild-wait-list-14-msg"], channelName)
  
  SendChatMessage(" "..strOfficerName, channelName)
  
  SendChatMessage(L["ann-guild-wait-list-15-msg"], channelName)
  SendChatMessage(L["ann-guild-wait-list-16-msg"], channelName)
end

-- ============================================================================
-- == AnnounceRaidEnd(channelName)                                           ==
-- ==                                                                        ==
-- == This function outputs an announcement in the channel specified by the  ==
-- == channelName parameter (typically "RAID") to inform players that the    ==
-- == raid has now ended.                                                    ==
-- ============================================================================

function ConvergeFu:AnnounceRaidEnd(channelName)
  
  strGMOTD = L["common-motd-raidended-01"]
          
  GuildSetMOTD(strGMOTD)
  
  SendChatMessage(L["ann-raid-raid-end-02-msg"], "RAID_WARNING")
  SendChatMessage(L["ann-raid-raid-end-04-msg"], "RAID_WARNING")
  SendChatMessage(L["ann-raid-raid-end-10-msg"], "RAID_WARNING")
  SendChatMessage(L["ann-raid-raid-end-12-msg"], "RAID_WARNING")

  SendChatMessage(L["ann-raid-raid-end-01-msg"], channelName)
  SendChatMessage(L["ann-raid-raid-end-02-msg"], channelName)
  SendChatMessage(L["ann-raid-raid-end-03-msg"], channelName)
  SendChatMessage(L["ann-raid-raid-end-04-msg"], channelName)
  SendChatMessage(L["ann-raid-raid-end-05-msg"], channelName)
  SendChatMessage(L["ann-raid-raid-end-06-msg"], channelName)
  SendChatMessage(L["ann-raid-raid-end-07-msg"], channelName)
  SendChatMessage(L["ann-raid-raid-end-08-msg"], channelName)
  SendChatMessage(L["ann-raid-raid-end-09-msg"], channelName)
  SendChatMessage(L["ann-raid-raid-end-10-msg"], channelName)
  SendChatMessage(L["ann-raid-raid-end-11-msg"], channelName)
  SendChatMessage(L["ann-raid-raid-end-12-msg"], channelName)
  SendChatMessage(L["ann-raid-raid-end-13-msg"], channelName)

end

-- ============================================================================
-- == GetSpecialMenu()                                                       ==
-- ==                                                                        ==
-- == This function is a work-in-progress. For now, it should be paid little ==
-- == heed and unscrupulously ignored, except where circumstance and urgent  ==
-- == necessity demand otherwise.                                            ==
-- ============================================================================

function ConvergeFu:GetSpecialMenu()
  return { 
    threat = { 
       name = L["ann-say-threat-title"], 
       desc = L["ann-say-threat-descr"], 
       type = 'execute', 
       func = function() SendChatMessage(L["ann-say-threat-msg"], "SAY") end
    }
  }
end